---
title: DataTransfer.types
slug: Web/API/DataTransfer/types
tags:
  - API
  - HTML DOM
  - Property
  - Reference
  - drag and drop
---
<div>{{APIRef("HTML Drag and Drop API")}}</div>

<p>The <strong><code>DataTransfer.types</code></strong> read-only property returns an array of the drag data formats (as {{domxref("DOMString","strings")}}) that were set in the {{event("dragstart")}} event. The order of the formats is the same order as the data included in the drag operation.</p>

<p>The formats are Unicode strings giving the type or format of the data, generally given by a MIME type. Some values that are not MIME types are special-cased for legacy reasons (for example "<code>text</code>"). </p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><var>dataTransfer</var>.types;
</pre>

<h3 id="Return_value">Return value</h3>

<p>An array of the data formats used in the drag operation. Each format is {{domxref("DOMString","string")}}. If the drag operation included no data, this list will be empty. If any files are included in the drag operation, then one of the types will be the string <code>Files</code>. </p>

<h2 id="Example">Example</h2>

<p>This example shows the use of the <code>types</code> and {{domxref("DataTransfer.items","items")}} properties.</p>

<pre class="brush: js">&lt;!DOCTYPE html&gt;
&lt;html lang=en&gt;
&lt;title&gt;Examples of DataTransfer.{types,items} properties&lt;/title&gt;
&lt;meta content="width=device-width"&gt;
&lt;style&gt;
  div {
    margin: 0em;
    padding: 2em;
  }
  #target {
    border: 1px solid black;
  }
&lt;/style&gt;
&lt;script&gt;
function dragstart_handler(ev) {
 console.log("dragStart: target.id = " + ev.target.id);
 // Add this element's id to the drag payload so the drop handler will
 // know which element to add to its tree
 ev.dataTransfer.setData("text/plain", ev.target.id);
 ev.dataTransfer.effectAllowed = "move";
}

function drop_handler(ev) {
 console.log("drop: target.id = " + ev.target.id);
 ev.preventDefault();
 // Get the id of the target and add the moved element to the target's DOM
 var data = ev.dataTransfer.getData("text");
 ev.target.appendChild(document.getElementById(data));
 // Print each format type
 if (ev.dataTransfer.types != null) {
   for (var i=0; i &lt; ev.dataTransfer.types.length; i++) {
     console.log("... types[" + i + "] = " + ev.dataTransfer.types[i]);
   }
 }
 // Print each item's "kind" and "type"
 if (ev.dataTransfer.items != null) {
   for (var i=0; i &lt; ev.dataTransfer.items.length; i++) {
     console.log("... items[" + i + "].kind = " + ev.dataTransfer.items[i].kind + " ; type = " + ev.dataTransfer.items[i].type);
   }
 }
}

function dragover_handler(ev) {
 console.log("dragOver");
 ev.preventDefault();
 // Set the dropEffect to move
 ev.dataTransfer.dropEffect = "move"
}
&lt;/script&gt;
&lt;body&gt;
&lt;h1&gt;Examples of &lt;code&gt;DataTransfer&lt;/code&gt;.{&lt;code&gt;types&lt;/code&gt;, &lt;code&gt;items&lt;/code&gt;} properties&lt;/h1&gt;
 &lt;ul&gt;
   &lt;li id="i1" ondragstart="dragstart_handler(event);" draggable="true"&gt;Drag Item 1 to the Drop Zone&lt;/li&gt;
   &lt;li id="i2" ondragstart="dragstart_handler(event);" draggable="true"&gt;Drag Item 2 to the Drop Zone&lt;/li&gt;
 &lt;/ul&gt;
 &lt;div id="target" ondrop="drop_handler(event);" ondragover="dragover_handler(event);"&gt;Drop Zone&lt;/div&gt;
&lt;/body&gt;
&lt;/html&gt;
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("HTML WHATWG", "interaction.html#dom-datatransfer-types", "types")}}</td>
   <td>{{Spec2("HTML WHATWG")}}</td>
   <td> </td>
  </tr>
  <tr>
   <td>{{SpecName("HTML5.1", "editing.html#dom-datatransfer-types", "types")}}</td>
   <td>{{Spec2("HTML5.1")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.DataTransfer.types")}}</p>

<h2 id="See_also">See also</h2>

<p>{{page("/en-US/docs/Web/API/DataTransfer", "See also")}}</p>
